Index: /palm/trunk/SOURCE/date_and_time_mod.f90
===================================================================
--- /palm/trunk/SOURCE/date_and_time_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/date_and_time_mod.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Tabs removed
+! 
+! 3458 2018-10-30 14:51:23Z kanani
 ! from chemistry branch r3443, banzhafs:
 ! Added initial hour_of_day, hour_of_year, day_of_year and month_of_year to
@@ -563,9 +566,9 @@
     ELSE 
 
-    	DO i_mon=1,index_mm
+    DO i_mon=1,index_mm
        
-            sum_dd=sum_dd+days(i_mon)
-
-        ENDDO
+       sum_dd=sum_dd+days(i_mon)
+
+    ENDDO
       
     index_hh=(sum_dd*nhour)+(index_dd*nhour)+(hh)
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 3466)
+++ /palm/trunk/SOURCE/header.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Add biometeorology
 ! 
@@ -484,4 +487,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_header
+               
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_header        
     
     USE spectra_mod,                                                           &
@@ -2061,4 +2067,8 @@
        ENDIF
     ENDIF
+    
+!
+!-- SALSA information
+    IF ( salsa )  CALL salsa_header( io ) 
 
 !
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 3466)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3458 2018-10-30 14:51:23Z kanani
 ! from chemistry branch r3443, basit:
 ! bug fixed in sums and sums_l for chemistry profile output
@@ -618,7 +621,10 @@
     USE random_generator_parallel,                                             &
         ONLY:  init_parallel_random_generator
-
+        
     USE read_restart_data_mod,                                                 &
-        ONLY:  rrd_read_parts_of_global, rrd_local                                      
+        ONLY:  rrd_read_parts_of_global, rrd_local    
+             
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_init, salsa_init_arrays      
     
     USE statistics,                                                            &
@@ -1065,4 +1071,5 @@
     IF ( land_surface        )  CALL lsm_init_arrays
     IF ( ocean_mode          )  CALL ocean_init_arrays
+    IF ( salsa               )  CALL salsa_init_arrays
     IF ( wind_turbine        )  CALL wtm_init_arrays
     IF ( uv_exposure         )  CALL uvem_init_arrays
@@ -2413,4 +2420,12 @@
 
 !
+!-- If required, initialize quantities needed in SALSA 
+    IF ( salsa )  THEN
+       CALL location_message( 'initializing SALSA model', .TRUE. )
+       CALL salsa_init 
+       CALL location_message( 'finished', .TRUE. )
+    ENDIF
+
+!
 !-- If required, initialize quantities needed for the gust module
     IF ( gust_module_enabled )  THEN
Index: /palm/trunk/SOURCE/init_masks.f90
===================================================================
--- /palm/trunk/SOURCE/init_masks.f90	(revision 3466)
+++ /palm/trunk/SOURCE/init_masks.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3435 2018-10-26 18:25:44Z gronemeier
 ! Add checks for chemistry and radiation model
 ! Set indices for terrain-following masked output
@@ -180,8 +183,11 @@
         ONLY:  particle_advection
 
-    USE pegrid
+    USE pegrid  
 
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_check_data_output
+        
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_check_data_output 
 
     IMPLICIT NONE
@@ -477,4 +483,8 @@
              
                 CALL user_check_data_output( var, unit )
+                           
+                IF ( salsa )  THEN
+                   CALL salsa_check_data_output( var, unit )
+                ENDIF               
 
                 IF ( unit == 'illegal'  .AND.  air_chemistry                   &
Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Salsa implemented
+! 
+! 3464 2018-10-30 18:08:55Z kanani
 ! Define coordinate reference system (crs) and read from input dataset
 ! Revise default values for reference coordinates
@@ -776,9 +779,10 @@
 !-- Public subroutines
     PUBLIC netcdf_data_input_check_dynamic, netcdf_data_input_check_static,    &
-           netcdf_data_input_chemistry_data, netcdf_data_input_inquire_file,                                     &
+           netcdf_data_input_chemistry_data, netcdf_data_input_inquire_file,   &
            netcdf_data_input_init, netcdf_data_input_init_lsm,                 &
            netcdf_data_input_init_3d,                                          &
            netcdf_data_input_interpolate, netcdf_data_input_offline_nesting,   &
-           netcdf_data_input_surface_data, netcdf_data_input_topo
+           netcdf_data_input_surface_data, netcdf_data_input_topo,             &
+           get_attribute, get_dimension_length, get_variable, open_read_file
 
  CONTAINS
Index: /palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3467)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! - Salsa implemented
+! - Bugfix convert_utm_to...
+! 
+! 3464 2018-10-30 18:08:55Z kanani
 ! - Add variable crs to output files
 ! - Add long_name to UTM coordinates
@@ -103,5 +107,5 @@
 ! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
-! 
+!
 ! 2696 2017-12-14 17:12:51Z kanani
 ! Change in file header (GPL part)
@@ -659,5 +663,8 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY: radiation, radiation_define_netcdf_grid
+        ONLY: radiation, radiation_define_netcdf_grid      
+     
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_define_netcdf_grid             
 
     USE spectra_mod,                                                           &
@@ -1164,5 +1171,5 @@
                 CASE DEFAULT
 !
-!--                Check for quantities defined in other modules
+!--                Check for quantities defined in other modules                                                        
                    CALL tcm_define_netcdf_grid( domask( mid,av,i), found,      &
                                                         grid_x, grid_y, grid_z )
@@ -1198,4 +1205,10 @@
                                                          grid_z )
                    ENDIF
+!
+!--                Check for SALSA quantities
+                   IF ( .NOT. found  .AND.  salsa )  THEN
+                      CALL salsa_define_netcdf_grid( domask(mid,av,i), found,  &
+                                                     grid_x, grid_y, grid_z )
+                   ENDIF                  
 !
 !--                Now check for user-defined quantities
@@ -2034,4 +2047,11 @@
                    ENDIF
 
+!
+!--                Check for SALSA quantities
+                   IF ( .NOT. found  .AND.  salsa )  THEN
+                      CALL salsa_define_netcdf_grid( do3d(av,i), found, grid_x,&
+                                                     grid_y, grid_z )
+                   ENDIF                 
+                   
 !--                Check for user-defined quantities
                    IF ( .NOT. found )  THEN
@@ -3057,4 +3077,12 @@
                                                          grid_z )
                          ENDIF
+                         
+!
+!--                      Check for SALSA quantities
+                         IF ( .NOT. found  .AND.  salsa )  THEN
+                            CALL salsa_define_netcdf_grid( do2d(av,i), found,  &
+                                                           grid_x, grid_y,     &
+                                                           grid_z )
+                         ENDIF                       
 
 !
@@ -4037,4 +4065,11 @@
                                                             grid_z )
                       ENDIF
+                      
+!
+!--                   Check for SALSA quantities
+                      IF ( .NOT. found  .AND.  salsa )  THEN
+                         CALL salsa_define_netcdf_grid( do2d(av,i), found,     &
+                                                        grid_x, grid_y, grid_z )
+                      ENDIF                         
 
 !
@@ -4970,5 +5005,11 @@
                                                             grid_z )
                       ENDIF
-
+                      
+!
+!--                   Check for SALSA quantities
+                      IF ( .NOT. found  .AND.  salsa )  THEN
+                         CALL salsa_define_netcdf_grid( do2d(av,i), found,     &
+                                                        grid_x, grid_y, grid_z )
+                      ENDIF                           
 !
 !--                   Check for gust module quantities
@@ -7231,4 +7272,5 @@
 
        WRITE( message_identifier, '(''NC'',I4.4)' )  errno
+
        message_string = TRIM( NF90_STRERROR( nc_stat ) )
 
@@ -7435,4 +7477,6 @@
     IMPLICIT NONE
 
+    INTEGER(iwp) ::  j   !< loop index
+    
     REAL(wp), INTENT(in)  ::  eutm !< easting (UTM)
     REAL(wp), INTENT(out) ::  lat  !< geographic latitude in degree
@@ -7447,5 +7491,4 @@
     REAL(wp) ::  eta         !<
     REAL(wp) ::  eta_s       !<
-    REAL(wp) ::  j           !< loop index
     REAL(wp) ::  n           !< 3rd flattening
     REAL(wp) ::  n2          !< n^2
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 3466)
+++ /palm/trunk/SOURCE/parin.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Add biometeorology
 ! 
@@ -520,5 +523,8 @@
 
     USE read_restart_data_mod,                                                 &
-        ONLY:  rrd_global     
+        ONLY:  rrd_global  
+             
+    USE salsa_mod,                                                             &
+        ONLY: salsa_parin          
 
     USE spectra_mod,                                                           &
@@ -912,4 +918,8 @@
           CALL uvem_parin
 !
+!--       Check if SALSA processes should be carried out and read &salsa_par
+!--       if required
+          CALL salsa_parin          
+!
 !--       Read user-defined variables
           CALL user_parin
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3467)
@@ -299,7 +299,7 @@
 !
 !-- Public variables and constants
-    PUBLIC pc_heating_rate, pc_transpiration_rate, pc_latent_rate,             &
-            canopy_mode, cthf, dt_plant_canopy, lad, lad_s, pch_index,         &
-            plant_canopy_transpiration
+    PUBLIC cdc, pc_heating_rate, pc_transpiration_rate, pc_latent_rate,       &
+           canopy_mode, cthf, dt_plant_canopy, lad, lad_s, pch_index,         &
+           plant_canopy_transpiration
 
     INTERFACE pcm_calc_transpiration_rate
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3466)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3467)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! Remove cpu-logs from i,j loop in cache version.
+! 
+! 3458 2018-10-30 14:51:23Z kanani
 ! remove duplicate USE chem_modules
 ! from chemistry branch r3443, banzhafs, basit:
@@ -368,5 +372,6 @@
                timestep_scheme, tsc, use_subsidence_tendencies,                &
                use_upstream_for_tke, wind_turbine, ws_scheme_mom,              & 
-               ws_scheme_sca, urban_surface, land_surface
+               ws_scheme_sca, urban_surface, land_surface,                     &
+               time_since_reference_point
 
     USE coriolis_mod,                                                          &
@@ -407,5 +412,14 @@
         ONLY:  radiation, radiation_tendency,                                  &
                skip_time_do_radiation
-
+                          
+    USE salsa_mod,                                                             &
+        ONLY:  aerosol_mass, aerosol_number, dt_salsa, last_salsa_time, nbins, &
+               ncc_tot, ngast, salsa, salsa_boundary_conds, salsa_diagnostics, &
+               salsa_driver, salsa_gas, salsa_gases_from_chem, salsa_tendency, &
+               skip_time_do_salsa
+               
+    USE salsa_util_mod,                                                        &
+        ONLY:  sums_salsa_ws_l                              
+    
     USE statistics,                                                            &
         ONLY:  hom
@@ -460,5 +474,8 @@
 
     IMPLICIT NONE
-
+    
+    INTEGER(iwp) ::  b                   !< index for aerosol size bins (salsa)
+    INTEGER(iwp) ::  c                   !< index for chemical compounds (salsa)
+    INTEGER(iwp) ::  g                   !< index for gaseous compounds (salsa)
     INTEGER(iwp) ::  i                   !<
     INTEGER(iwp) ::  i_omp_start         !<
@@ -523,5 +540,6 @@
              lsp_usr = lsp_usr +1
           ENDDO
-         
+
+
        ENDDO
        CALL cpu_log( log_point_s(84), 'chemistry exch-horiz ', 'stop' )
@@ -530,4 +548,61 @@
 
     ENDIF       
+
+!
+!-- Run SALSA and aerosol dynamic processes. SALSA is run with a longer time 
+!-- step. The exchange of ghost points is required after this update of the 
+!-- concentrations of aerosol number and mass 
+    IF ( salsa )  THEN
+       
+       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN                 
+          IF ( ( time_since_reference_point - last_salsa_time ) >= dt_salsa )  &
+          THEN
+             CALL cpu_log( log_point_s(90), 'salsa processes ', 'start' )
+             !$OMP PARALLEL PRIVATE (i,j,b,c,g)
+             !$OMP DO
+!
+!--          Call salsa processes
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   CALL salsa_diagnostics( i, j )
+                   CALL salsa_driver( i, j, 3 )
+                   CALL salsa_diagnostics( i, j )
+                ENDDO
+             ENDDO
+             
+             CALL cpu_log( log_point_s(90), 'salsa processes ', 'stop' )
+             
+             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'start' )
+!
+!--          Exchange ghost points and decycle if needed.
+             DO  b = 1, nbins
+                CALL exchange_horiz( aerosol_number(b)%conc, nbgp )
+                CALL salsa_boundary_conds( aerosol_number(b)%conc_p,           &
+                                           aerosol_number(b)%init )
+                DO  c = 1, ncc_tot
+                   CALL exchange_horiz( aerosol_mass((c-1)*nbins+b)%conc, nbgp )
+                   CALL salsa_boundary_conds(                                  &
+                                           aerosol_mass((c-1)*nbins+b)%conc_p, &
+                                           aerosol_mass((c-1)*nbins+b)%init )
+                ENDDO
+             ENDDO
+             
+             IF ( .NOT. salsa_gases_from_chem )  THEN
+                DO  g = 1, ngast
+                   CALL exchange_horiz( salsa_gas(g)%conc, nbgp )
+                   CALL salsa_boundary_conds( salsa_gas(g)%conc_p,             &
+                                              salsa_gas(g)%init )
+                ENDDO
+             ENDIF
+             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
+             
+             !$OMP END PARALLEL
+             last_salsa_time = time_since_reference_point
+             
+          ENDIF
+          
+       ENDIF
+       
+    ENDIF 
 
 !
@@ -549,5 +624,6 @@
 !
 !-- Loop over all prognostic equations
-    !$OMP PARALLEL PRIVATE (i,i_omp_start,j,k,loop_start,tn)
+!-- b, c ang g added for SALSA
+    !$OMP PARALLEL PRIVATE (i,i_omp_start,j,k,loop_start,tn,b,c,g)
 
     !$  tn = omp_get_thread_num()
@@ -1310,5 +1386,4 @@
           IF ( air_chemistry )  THEN
              !> TODO: remove time measurement since it slows down performance because it will be called extremely often
-             CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'start' )
 !
 !--          Loop over chemical species
@@ -1324,6 +1399,5 @@
                                      chem_species(lsp)%diss_l_cs )       
              ENDDO
-
-             CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'stop' )             
+          
           ENDIF   ! Chemical equations
 !
@@ -1332,4 +1406,54 @@
              CALL ocean_prognostic_equations( i, j, i_omp_start, tn )
           ENDIF
+       
+          IF ( salsa )  THEN 
+!
+!--          Loop over aerosol size bins: number and mass bins
+             IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
+             
+                DO  b = 1, nbins                
+                   sums_salsa_ws_l = aerosol_number(b)%sums_ws_l
+                   CALL salsa_tendency( 'aerosol_number',                      &
+                                         aerosol_number(b)%conc_p,             &
+                                         aerosol_number(b)%conc,               &
+                                         aerosol_number(b)%tconc_m,            &
+                                         i, j, i_omp_start, tn, b, b,          &
+                                         aerosol_number(b)%flux_s,             &
+                                         aerosol_number(b)%diss_s,             &
+                                         aerosol_number(b)%flux_l,             &
+                                         aerosol_number(b)%diss_l,             &
+                                         aerosol_number(b)%init )
+                   aerosol_number(b)%sums_ws_l = sums_salsa_ws_l
+                   DO  c = 1, ncc_tot
+                      sums_salsa_ws_l = aerosol_mass((c-1)*nbins+b)%sums_ws_l 
+                      CALL salsa_tendency( 'aerosol_mass',                     &
+                                            aerosol_mass((c-1)*nbins+b)%conc_p,&
+                                            aerosol_mass((c-1)*nbins+b)%conc,  &
+                                            aerosol_mass((c-1)*nbins+b)%tconc_m,&
+                                            i, j, i_omp_start, tn, b, c,       &
+                                            aerosol_mass((c-1)*nbins+b)%flux_s,&
+                                            aerosol_mass((c-1)*nbins+b)%diss_s,&
+                                            aerosol_mass((c-1)*nbins+b)%flux_l,&
+                                            aerosol_mass((c-1)*nbins+b)%diss_l,&
+                                            aerosol_mass((c-1)*nbins+b)%init )
+                      aerosol_mass((c-1)*nbins+b)%sums_ws_l = sums_salsa_ws_l
+                   ENDDO
+                ENDDO
+                IF ( .NOT. salsa_gases_from_chem )  THEN
+                   DO  g = 1, ngast
+                      sums_salsa_ws_l = salsa_gas(g)%sums_ws_l
+                      CALL salsa_tendency( 'salsa_gas', salsa_gas(g)%conc_p,   &
+                                      salsa_gas(g)%conc, salsa_gas(g)%tconc_m, &
+                                      i, j, i_omp_start, tn, g, g,             &
+                                      salsa_gas(g)%flux_s, salsa_gas(g)%diss_s,&
+                                      salsa_gas(g)%flux_l, salsa_gas(g)%diss_l,&
+                                      salsa_gas(g)%init )
+                      salsa_gas(g)%sums_ws_l = sums_salsa_ws_l
+                   ENDDO
+                ENDIF
+             
+             ENDIF
+             
+          ENDIF        
 
        ENDDO  ! loop over j
@@ -1355,4 +1479,7 @@
     IMPLICIT NONE
 
+    INTEGER(iwp) ::  b     !< index for aerosol size bins (salsa)
+    INTEGER(iwp) ::  c     !< index for chemical compounds (salsa)
+    INTEGER(iwp) ::  g     !< index for gaseous compounds (salsa)
     INTEGER(iwp) ::  i     !<
     INTEGER(iwp) ::  j     !<
@@ -1362,4 +1489,62 @@
     REAL(wp)     ::  sbt  !<
 
+!
+!-- Run SALSA and aerosol dynamic processes. SALSA is run with a longer time 
+!-- step. The exchange of ghost points is required after this update of the 
+!-- concentrations of aerosol number and mass 
+    IF ( salsa )  THEN
+       
+       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
+       
+          IF ( ( time_since_reference_point - last_salsa_time ) >= dt_salsa )  &
+          THEN
+          
+             CALL cpu_log( log_point_s(90), 'salsa processes ', 'start' )
+             !$OMP PARALLEL PRIVATE (i,j,b,c,g)
+             !$OMP DO
+!
+!--          Call salsa processes
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   CALL salsa_diagnostics( i, j )
+                   CALL salsa_driver( i, j, 3 )
+                   CALL salsa_diagnostics( i, j )
+                ENDDO
+             ENDDO
+             
+             CALL cpu_log( log_point_s(90), 'salsa processes ', 'stop' )
+             
+             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'start' )
+!
+!--          Exchange ghost points and decycle if needed.
+             DO  b = 1, nbins
+                CALL exchange_horiz( aerosol_number(b)%conc, nbgp )
+                CALL salsa_boundary_conds( aerosol_number(b)%conc_p,           &
+                                           aerosol_number(b)%init )
+                DO  c = 1, ncc_tot
+                   CALL exchange_horiz( aerosol_mass((c-1)*nbins+b)%conc, nbgp )
+                   CALL salsa_boundary_conds(                                  &
+                                           aerosol_mass((c-1)*nbins+b)%conc_p, &
+                                           aerosol_mass((c-1)*nbins+b)%init )
+                ENDDO
+             ENDDO
+             
+             IF ( .NOT. salsa_gases_from_chem )  THEN
+                DO  g = 1, ngast
+                   CALL exchange_horiz( salsa_gas(g)%conc, nbgp )
+                   CALL salsa_boundary_conds( salsa_gas(g)%conc_p,             &
+                                              salsa_gas(g)%init )
+                ENDDO
+             ENDIF
+             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
+             
+             !$OMP END PARALLEL
+             last_salsa_time = time_since_reference_point
+             
+          ENDIF
+          
+       ENDIF
+       
+    ENDIF 
 
 !
@@ -2392,4 +2577,42 @@
        CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'stop' )             
     ENDIF   ! Chemicals equations
+        
+    IF ( salsa )  THEN 
+       CALL cpu_log( log_point_s(92), 'salsa advec+diff+prog ', 'start' )
+!
+!--          Loop over aerosol size bins: number and mass bins
+       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
+       
+          DO  b = 1, nbins                
+             sums_salsa_ws_l = aerosol_number(b)%sums_ws_l
+             CALL salsa_tendency( 'aerosol_number', aerosol_number(b)%conc_p,  &
+                                   aerosol_number(b)%conc,                     &
+                                   aerosol_number(b)%tconc_m,                  &
+                                   b, b, aerosol_number(b)%init )
+             aerosol_number(b)%sums_ws_l = sums_salsa_ws_l
+             DO  c = 1, ncc_tot
+                sums_salsa_ws_l = aerosol_mass((c-1)*nbins+b)%sums_ws_l 
+                CALL salsa_tendency( 'aerosol_mass',                           &
+                                      aerosol_mass((c-1)*nbins+b)%conc_p,      &
+                                      aerosol_mass((c-1)*nbins+b)%conc,        &
+                                      aerosol_mass((c-1)*nbins+b)%tconc_m,     &
+                                      b, c, aerosol_mass((c-1)*nbins+b)%init )
+                aerosol_mass((c-1)*nbins+b)%sums_ws_l = sums_salsa_ws_l
+             ENDDO
+          ENDDO
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  g = 1, ngast
+                sums_salsa_ws_l = salsa_gas(g)%sums_ws_l
+                CALL salsa_tendency( 'salsa_gas', salsa_gas(g)%conc_p,         &
+                                      salsa_gas(g)%conc, salsa_gas(g)%tconc_m, &
+                                      g, g, salsa_gas(g)%init )
+                salsa_gas(g)%sums_ws_l = sums_salsa_ws_l
+             ENDDO
+          ENDIF
+       
+       ENDIF
+       
+       CALL cpu_log( log_point_s(92), 'salsa advec+diff+prog ', 'stop' )
+    ENDIF  
 
 !
Index: /palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3467)
@@ -1085,4 +1085,7 @@
     USE random_generator_parallel,                                             &
         ONLY:  id_random_array, seq_random_array
+    
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_rrd_local
 
     USE surface_mod,                                                           &
@@ -1907,4 +1910,9 @@
                                            nyn_on_file, nysf, nysc,            &
                                            nys_on_file, found )
+!
+!--                Read salsa restart data
+                   IF ( .NOT. found  .AND.  salsa )  THEN
+                      CALL salsa_rrd_local
+                   ENDIF                                               
 
 !
